/**
 * SKEDNET ENGINE
 * startup script
 */

var views = "mvc/views/"; // HTML components folder
var dNL = jQuery.mobile.datebox.prototype.options.lang.nl;
var EMPTYGUID = "00000000-0000-0000-0000-000000000000";
var D; // User Data object
var FreeRequests;

// Step 1
$(document).on("pagecreate", "#index-page", function(event) {
	console.log("pagecreate");
	//$.mobile.changePage("login.html");
    //if(verifyLogin())
    	//$.mobile.changePage("news.html");
});


// Step 2
/**
 * @return true if user is logged in;
 * else go to login screen 
 */
function verifyLogin() {
	console.log("verifylogin");
    if (D != null && D != undefined && D.Employee != undefined && D.Employee != null)
        return true;            
    //$(":mobile-pagecontainer").pagecontainer("change", "/login.html", { allowSamePageTransition: true });    
    //$(":mobile-pagecontainer").pagecontainer("change", "http://www.nu.nl", { allowSamePageTransition: true });
    $.mobile.pageContainer.pagecontainer("change", "login.html", {  allowSamePageTransition: true, reload: false, changeHash: false });
}

function showLoading()
{
	if($(":mobile-pagecontainer").pagecontainer("getActivePage").attr("id") != "options-page") {
    	$.mobile.loading( "show", {
		  text: "Laden..",
		  textVisible: true,
		  theme: "b",
		  html: ""
		});
    }    
}

function hideLoading()
{
	$.mobile.loading("hide");
}

$(document).on("pageshow", "div:jqmData(role='page')", function(event, ui) {
    var pageID = $(":mobile-pagecontainer").pagecontainer("getActivePage").attr("id");
   
    console.log('PageShow Fired - current page = ' + pageID);
    $.mobile.silentScroll(0);    
    //hideLoading();
        
    if($.inArray(pageID, ["employee-page", "freerequests-page", "colleagues-page"]) > -1 && isDisabled("Web_ShowColleagues")) {
        $("#colleagues-button").remove();
        $(".emp-subnav ul").removeClass("ui-grid-b");
        $(".emp-subnav ul").addClass("ui-grid-a");
    }
    
    else if($.inArray(pageID, ["pschedule-page", "dschedule-page"]) > -1 && isDisabled("Web_ShowDaily")) {
        $('.schedule-subnav').remove();
    }
});



$(document).on("pagehide", "div:jqmData(role='page')", function(event, ui) {
    console.log('PageHide Fired - Active page: '+ ui.nextPage);
    $.mobile.silentScroll(0);
    //showLoading();
});

/**
 * Returns if the provided setting is either true or false
 */
function isDisabled(settingName) {
    for(i = 0; i < D.Settings.length; i++) {
        var curSetting = D.Settings[i];
        if(curSetting.Name == settingName) {
            return curSetting.Value == "False";
        }
    }
    return false;
}

function showNotification(title, message) {
    //alert(title + " - " + message);
    
    navigator.notification.alert(message, null, title, "OK");
    navigator.notification.beep(1);
    navigator.notification.vibrate(200);
}

function dismissNotification() {
    // nothing
}

/**
 * Load the content of a HTML-page inside a div
 * @param id - id of the div to fill
 * @param page - the HTML-page to load
 */
function loadDiv(id, page) {
    $.ajax({
        url : page,
        async : false,
        success : function(data) {
            $(id).html(data);
        }
    });
}

/**
 * Show Toast message
 */
function toast(msg) {
    
   if(window.localStorage.getItem("newFRmsg") == null) {
        var container = $(document.createElement("div"));
        container.addClass("toast");
    
        var message = $(document.createElement("div"));
        message.addClass("message");
        message.text(msg);
        message.appendTo(container);
    
        container.appendTo(document.body);
        container.delay(100).fadeIn("slow", function() { });
        container.click(function () {  
            $(this).delay(200).fadeOut("slow", function() {
                $(this).remove();
            });
            window.localStorage.setItem("newFRmsg", "hide");
        });
        $(container).delay(2000).fadeOut("slow", function() {
            $(this).remove();
        });
    }
}

function getEmployeeName() {
    if(D.Employee == null || D.Employee == undefined)
        return "Werknemer";
    return D.Employee.EM_FirstName + " " + D.Employee.EM_LastName;
}

function getFrType(typeID) {
    for(var i = 0; i < D.FRTypes.length; i++) {
        if(D.FRTypes[i].FreeRequestTypeID == typeID)
            return D.FRTypes[i];
    }
    return null;
}

function getFrTypeID(typeName) {
    for(var i = 0; i < D.FRTypes.length; i++) {
        if(D.FRTypes[i].FRT_Name == typeName)
            return D.FRTypes[i].FreeRequestTypeID;
    }
    return null;
}

//////* DATE FUNCTIONS *//////

function getDateFromJSON(jsonDate) {
    var d = new Date(parseInt(jsonDate.substr(6)));
        d.setMinutes(d.getMinutes() + d.getTimezoneOffset());
    return d;
}


Date.prototype.getWeek = function(){
    // We have to compare against the first monday of the year not the 01/01
    // 60*60*24*1000 = 86400000
    // 'onejan_next_monday_time' reffers to the miliseconds of the next monday after 01/01

    var day_miliseconds = 86400000,
        onejan = new Date(this.getFullYear(),0,1,0,0,0),
        onejan_day = (onejan.getDay()==0) ? 7 : onejan.getDay(),
        days_for_next_monday = (8-onejan_day),
        onejan_next_monday_time = onejan.getTime() + (days_for_next_monday * day_miliseconds),
        // If one jan is not a monday, get the first monday of the year
        first_monday_year_time = (onejan_day>1) ? onejan_next_monday_time : onejan.getTime(),
        this_date = new Date(this.getFullYear(), this.getMonth(),this.getDate(),0,0,0),// This at 00:00:00
        this_time = this_date.getTime(),
        days_from_first_monday = Math.round(((this_time - first_monday_year_time) / day_miliseconds));

    var first_monday_year = new Date(first_monday_year_time);

    // We add 1 to "days_from_first_monday" because if "days_from_first_monday" is *7,
    // then 7/7 = 1, and as we are 7 days from first monday,
    // we should be in week number 2 instead of week number 1 (7/7=1)
    // We consider week number as 52 when "days_from_first_monday" is lower than 0,
    // that means the actual week started before the first monday so that means we are on the firsts
    // days of the year (ex: we are on Friday 01/01, then "days_from_first_monday"=-3,
    // so friday 01/01 is part of week number 52 from past year)
    // "days_from_first_monday<=364" because (364+1)/7 == 52, if we are on day 365, then (365+1)/7 >= 52 (Math.ceil(366/7)=53) and thats wrong

    return (days_from_first_monday>=0 && days_from_first_monday<364) ? Math.ceil((days_from_first_monday+1)/7) : 52;
}


Date.prototype.getWeekOld = function() {
            var THURSDAY = 4;
            var thursdayFlag = false;
            
            var onejan = new Date(this.getFullYear(), 0, 1);
            var today = new Date(this.getFullYear(), this.getMonth(), this.getDate());

            // Get the day number since the beginning of the year
            var dayOfYear = ((today - onejan + 1) / 86400000);

            // Get the numeric weekday of the first day of the 
            // year (using sunday as FirstDay)
            var startWeekDayOfYear = new Date(this.getFullYear(), 0, 1).getDay();
            var endWeekDayOfYear = new Date(this.getFullYear(), 11, 31).getDay();

            // Compensate for the fact that we are using monday as the first day of the week

            if (startWeekDayOfYear == 0)
                startWeekDayOfYear = 7;
            if (endWeekDayOfYear == 0)
                endWeekDayOfYear = 7;

            // Calculate the number of days in the first week
            var daysInFirstWeek = 8 - (startWeekDayOfYear);
            var daysInLastWeek = 8 - (endWeekDayOfYear);

            // If the year either starts or ends on a thursday it will have a 53rd week
            if (startWeekDayOfYear == THURSDAY || endWeekDayOfYear == THURSDAY)
                thursdayFlag = true;

            // We begin by calculating the number of FULL weeks between the start of the year and
            // our date. The number is rounded up, so the smallest possible value is 0.
            var fullWeeks = Math.ceil((dayOfYear - (daysInFirstWeek)) / 7.0);

            var weekNumber = fullWeeks;

            // If the first week of the year has at least four days, then the actual week number for our date
            // can be incremented by one.
            if (daysInFirstWeek >= THURSDAY)
                weekNumber = weekNumber + 1;

            // If week number is larger than week 52 (and the year doesn't either start or end on a thursday)
            // then the correct week number is 1.
            if (weekNumber > 52 && !thursdayFlag)
                weekNumber = 1;

            // If week number is still 0, it means that we are trying to evaluate the week number for a
            // week that belongs in the previous year (since that week has 3 days or less in our date's year).
            // We therefore make a recursive call using the last day of the previous year.
            if (weekNumber == 0)
                weekNumber = new Date(this.getFullYear() -1, 11, 31).getWeek();

            return weekNumber;
        }

/**
 * Format: 14-03-2012
 */
function parseDate(d) {
    return parseDigit(d.getDate()) + "-" + parseDigit(d.getMonth() + 1) + "-" + (d.getFullYear());
}
 
/**
 * Format: 14-03-2012 10:00
 */
function parseDateTimeFull(d) {
    return parseDate(d) + " " + parseTime(d);
}

/**
 * Format: wo 14 mrt
 */
function parseDateShort(d) {
    return (dNL.daysOfWeekShort[d.getDay()] + " " + d.getDate() + " " + dNL.monthsOfYearShort[d.getMonth()]);
}

/**
 * Format: woensdag 14 maart 2012
 */
function parseDateLong(d) {
    return dNL.daysOfWeek[d.getDay()] + " " + d.getDate() + " " + dNL.monthsOfYear[d.getMonth()] + " " + (d.getFullYear());
}

/**
 * Format: 10:00
 */
function parseTime(d) {
    return parseDigit(d.getHours()) + ":" + parseDigit(d.getMinutes());
}

/**
 * Format: 10:00 - 16:00
 * @param b - beginTime
 * @param e - endTime
 */
function parseShiftTimes(b, e) {
    return parseTime(b) + " - " + parseTime(e);    
}

/**
 * Format: wo 14 mrt 10:00 - 16:00
 * @param b - beginTime
 * @param e - endTime
 */
function parseShiftDateTimes(b, e) {
    return parseDateShort(b) + " &nbsp; &nbsp; " + parseShiftTimes(b,e);    
}

/**
 * Format: Van: wo 14 mrt 10:00  Tot: za 17 mrt 16:00
 * @param b - beginTime
 * @param e - endTime
 */
function parseFRDateTimes(b, e) {
    return "Van: " + parseDateShort(b) + " " + parseTime(b) + 
    " &nbsp &nbsp Tot: " + parseDateShort(e) + " " + parseTime(e);    
}

/**
 * Reset Time to 00:00:00
 */
function fixTimeOffset(d) {
    return new Date(Date.UTC(d.getFullYear(), d.getMonth(), d.getDate(), 0, 0, 0));
}

/**
 * Convert local timezone time to UTC / GMT
 */
function fixTimeZone(d) {
    return new Date(Date.UTC(d.getFullYear(), d.getMonth(), d.getDate(), d.getHours(), d.getMinutes(), 0));
}

//////* HTML ENCODING FUNCTIONS *//////

function html_decode(s) {
    return s.replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/&nbsp;/g, ' ').
    replace(/&amp;/g, '&').replace(/&quot;/g, '\\').replace(/&bull;/g, '*').
    replace(/&rsquo;/g, '\'').replace(/\\/g, "'");
}

function strip_html(s) {
    return s.replace(/<br>/gi, "").
    replace(/<a.*href="(.*?)".*>(.*?)<\/a>/gi, " $2 ($1) ").
    replace(/<(?:.|\s)*?>/g, "");
}

/**
 * TEMP FIX for img urls old website
 */
function parseImgFix(s) {
    return s.replace(/clients/g, "https://secure.skednet.com/clients").replace(/libraries/g, "https://secure.skednet.com/libraries");
}

/**
 * Make sure external urls are loaded in browser
 */
function parseURL(s) {
    return s.replace(/<a/g, "<a target='_blank' rel='external'");
}

//////* OTHER FUNCTIONS *//////

function intToHexColor(i) {
    i &= 16777215;
    i |= 1 << 24;
    return ['#', i.toString(16).substr(1, 6)].join('');
}

function parseDigit(i) {
    return i < 10 ? "0" + i : i;
}

/**
 * GET parameters from URL
 */
function getUrlVars() {
    var vars = [], hash;
    var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
    for(var i = 0; i < hashes.length; i++) {
        hash = hashes[i].split('=');
        vars.push(hash[0]);
        vars[hash[0]] = hash[1];
    }
    return vars;
}

function encode(s) {
    var k = 129, out = "";
    for(i = 0; i < s.length; ++i)
        out += String.fromCharCode(k ^ s.charCodeAt(i));
    return out;
}
