$(document).on("pagebeforeshow", "#employee-page", function(event) {
    loadEmployee();
});

$( document ).on("pageinit", "#employee-page", function() {
	console.log("RESIZE");
     $("#profile-wrapper").data("mobileIscrollview").resizeWrapper();
     $("#profile-wrapper").data("mobileIscrollview").refresh();
});

function loadEmployee() {
	
    $('#employee-title').children('h2').text(getEmployeeName());
    loadDiv('#profile-list', views + 'loading.html');

    $('#profile-list li').remove();
    $('#profile-list').append('<li data-role="list-divider" class="list-header">Persoonlijke gegevens</li>');
    
    addProfileRow("Nummer", D.Employee.EM_Number);
    addProfileRow("Voornaam", D.Employee.EM_FirstName);
    addProfileRow("Achternaam", D.Employee.EM_LastName);
    addProfileRow("Roepnaam", D.Employee.EM_NickName);  
    addProfileRow("Geslacht", D.Employee.EM_Gender);
    addProfileRow("Geboortedatum", parseDate(getDateFromJSON(D.Employee.EM_DateOfBirth)));
    addProfileRow("Datum in dienst", parseDate(getDateFromJSON(D.Employee.EM_DateOfEmployment)));
/*    addProfileRow("Uurloon", "&euro; " + D.Employee.EM_WagePerHour);    */
    addProfileRow("Contracturen", D.Employee.EM_Contracthours);
    addProfileRow("Straat", D.Employee.EM_Address);
    addProfileRow("Huisnummer", D.Employee.EM_HouseNumber);
    addProfileRow("Toevoeging", D.Employee.EM_HouseNumberExtra);
    addProfileRow("Postcode", D.Employee.EM_PostalCode);
    addProfileRow("Plaats", D.Employee.EM_City);
    addProfileRow("Telefoon", D.Employee.EM_Phone);
    addProfileRow("Mobiel", D.Employee.EM_Mobile);
    addProfileRow("E-mail", D.Employee.EM_Email);
    
    addProfileRow("Bedrijf", D.Company);
    addProfileRow("Locatie", D.Location.LO_Name);
    var depts = "";
    for(i = 0; i < D.Departments.length; i++)
        depts += D.Departments[i].DE_Name + " ";
    addProfileRow("Afdelingen", depts);
    
    //$("#profile-wrapper div .iscroll-content").append('<a data-role="button">Button ' + i + '</a>');    
    $('[data-role="content"]').trigger('create');
    $("#profile-wrapper").data("mobileIscrollview").resizeWrapper();
    $("#profile-wrapper").iscrollview("resizeWrapper");
    $("#profile-wrapper").iscrollview("refresh");
}

function addProfileRow(key, value) {
    if(value == null) value = "";
    $('#profile-list').append('<li style="padding: 9px 15px; border-top: 1px solid #15428B"><div class="ui-grid-a"><div class="ui-block-a">' + key + '</div>'
     + '<div class="ui-block-b">' + value + '</div></div></li>');
}

$(document).on("pagecreate", "#options-page", function(event) {
    $("#logout-button").click(function() {
        logout();
    });
    $("#exit-button").click(function() {
        jQuery(document).empty();
        navigator.app.exitApp();
    });
    $("#info-button").click(function() {
        getAppInfo();
    });
});

function showAppInfo(info) {
    $("#options-title h2").text("Skednet App info");
    var textInfo = "<img src='img/Skednet_online_logo.png' width='150' height='63'/><br/><br/>" +
    "Skednet Mobile App versie " + info.version + " <br/><br/>" +
    "<span class='tinyText'> 2012 <a href='" + info.url + "' rel='external'>" + info.author + "</a><br/><br/>" +
    "<a href='mailto:" + info.email + "'>" + info.email + "</a> &nbsp; <a href='http://www.skednet.com/app' target='_blank'>www.skednet.com/app</a>";
    if(!(typeof device === 'undefined')) {
        textInfo += "<br/><br/>Uitgevoerd met Cordova " + device.cordova + " op toestel " + 
        device.name + " (" + device.platform + " v" + device.version + ") " + device.uuid;
    }
    $("#options-content").html(textInfo);
    $("#options-content").trigger("create");
}