var statusHeaderTxt = "";

$(document).on("pagecreate", "#freerequests-page", function(event) {
    loadFreerequests();    
    toast("Klik op de + knop voor een nieuw verzoek");
});

function loadFreerequests() {
    statusHeaderTxt = "";
    loadDiv('#freerequests-list', views + 'loading.html');   
    getFRsRequest();
}

/**
 * Call webservice to get free requests of employee
 */
function getFRsRequest() {
    var data = { "key" : D.Key };
    return CallWCF('GetFreeRequestsEmployee', data, "getFRsResponse");
}

/**
 * Called after WCF responds
 */
function getFRsResponse(result) {
    $('#freerequests-list li').remove();
    if(result.d == null || result.d.length == 0) {
        $('#freerequests-list').append('<li>momenteel geen vrijverzoeken</li>');
    } else {
        FreeRequests = result.d;
        var curStatus = "";
        $.each(FreeRequests, function(index, FreeRequest) {         
            if(FreeRequest.FR_Status != curStatus) {
                curStatus = FreeRequest.FR_Status;
                addFrStatusDivider(curStatus);
            }
            FreeRequest.FR_Status == "P" ? addOpenFRItem(FreeRequest, index) : addClosedFRItem(FreeRequest);
        });
    }
    $('#freerequests-list').listview('refresh');
    if(lastPublishedSchedule == null)
        lastPublishedScheduleRequest();  
}

function addFrStatusDivider(curStatus) {
    curStatus = curStatus == "P" ? "Onbehandeld" : "Behandeld";
    if(curStatus != statusHeaderTxt)
        $('#freerequests-list').append('<li data-role="list-divider" class="list-header">' + curStatus + '</li>');
    statusHeaderTxt = curStatus;
}

function addOpenFRItem(FreeRequest, index) {
    
    var beginTime = getDateFromJSON(FreeRequest.FR_BeginTime);
    var endTime;
    if (FreeRequest.FR_EndTime == null || FreeRequest.FR_EndTime == undefined) {
        endTime = new Date(beginTime);
        endTime.setDate(beginTime.getDate() + 100);
    }
    else {    
     endTime = getDateFromJSON(FreeRequest.FR_EndTime);
    }

    var requestDate = getDateFromJSON(FreeRequest.FR_RequestDate);
    var FrType = getFrType(FreeRequest.FreeRequestTypeID);
    
    $('#freerequests-list').append('<li class="tinyText" data-icon="back">' +
    '<a href="new-freerequest.html?id=' + index + '"  title="Verzoek aanpassen">' + parseFRDateTimes(beginTime, endTime) +
    '<p class="tinyText fullText">' + FreeRequest.FR_Reason + '</p>' +
    '<div class="ui-grid-a"><div class="ui-block-a" style="color:' + intToHexColor(FrType.FRT_ColorInt) + '">' + FrType.FRT_Name + '</div>' +
    '<div class="ui-block-b gray right">' + parseDateTimeFull(requestDate) + '</div>' +
    '</div></a></li>');
}

function addClosedFRItem(FreeRequest) {
    
    var beginTime = getDateFromJSON(FreeRequest.FR_BeginTime);
    var endTime;
    if (FreeRequest.FR_EndTime == null || FreeRequest.FR_EndTime == undefined) {
        endTime = new Date(beginTime);
        endTime.setDate(beginTime.getDate() + 365);
    }
    else {
        endTime = getDateFromJSON(FreeRequest.FR_EndTime);
    }
    var requestDate = getDateFromJSON(FreeRequest.FR_RequestDate);
    var FrType = getFrType(FreeRequest.FreeRequestTypeID);
    
    var color = FreeRequest.FR_Status == "A" ? "green" : "red";
    var status = FreeRequest.FR_Status == "A" ? "Geaccepteerd" : "Afgewezen";
    
    if(FreeRequest.FR_Reply === undefined) FreeRequest.FR_Reply = "";
    var reply = FreeRequest.FR_Reply != "" ? '<br/> >>> ' + FreeRequest.FR_Reply : "";
    
    $('#freerequests-list').append('<li class="tinyText">' + parseFRDateTimes(beginTime, endTime) +
    '<p class="tinyText fullText">' + FreeRequest.FR_Reason + 
    '<br/><span class="reply">' + reply + '</span></p>' +
    '<div class="ui-grid-a w40pt">' + 
    '   <div class="ui-block-a" style="color:' + intToHexColor(FrType.FRT_ColorInt) + '">' + FrType.FRT_Name + '</div>' +
    '   <div class="ui-block-b gray">' + /*parseDateTimeFull(requestDate) + */ 
    '   <span class="ui-li-count right topAuto ' + color +'" style="border-radius:2px; -webkit-border-radius: 2px;">' + status + '</span></div>' +
    '</div></li>');
}
