var FreeRequest;
var defaultFreeRequestTypeId;

$(document).on("pagecreate", "#new-freerequest", function(event) {    
    initFreeRequestTypes();
    $("#submitFreeRequest").click(function() {
        submitFreeRequest();
    });
});

$(document).on("pageshow", "#new-freerequest", function(event) {
	var beginDate, endDate;
    var id = getUrlVars()["id"];
    if(id) {
        FreeRequest = FreeRequests[id];
    //    console.log(FreeRequest);
        $('#new-freerequest-title').children('h4').text("Verzoek aanpassen");
        $('#FR_reason').val(FreeRequest.FR_Reason);        
        $("#select-frtype").val(FreeRequest.FreeRequestTypeID).selectmenu('refresh');
        beginDate = getDateFromJSON(FreeRequest.FR_BeginTime);
        endDate = getDateFromJSON(FreeRequest.FR_EndTime);
    } else { 
        beginDate = new Date();
        beginDate.setDate(beginDate.getDate() + 7); // start 1 week from now
        beginDate.setHours(6, 0, 0, 0);
        endDate = new Date();
        endDate.setDate(beginDate.getDate());
        endDate.setHours(23, 45, 0, 0);
    }
    
    $('#FR_from').val(parseDate(beginDate));
    $('#FR_fromtime').val(parseTime(beginDate));
    $('#FR_to').val(parseDate(endDate));
    $('#FR_totime').val(parseTime(endDate));

});

$(document).on('click' ,'#new-freerequest a',function() {
        FreeRequest = undefined;
        delete FreeRequest;
});


function initFreeRequestTypes() {
	var count = 0;
	for(i = 0; i < D.FRTypes.length; i++) {  
		//style="color:' + intToHexColor(FrType.FRT_ColorInt) + '">' + FrType.FRT_Name + '</div>' +
		 var frType = D.FRTypes[i];    
		 if (frType.FRT_IsEnabledPortal){ 
		 	if (count == 0)
		 		defaultFreeRequestTypeId =  frType.FreeRequestTypeID;
		 		 	          	        
         	var options = "<option value='" + frType.FreeRequestTypeID + "'>" + frType.FRT_Name + "</option>";
        	 $("select#select-frtype").append(options);
        	 count++;
       	}
    }

    if(count <= 1){
    	$("select#select-frtype").remove();
    	$("#label-frtype").remove();
    }
    else{
    	$("select#select-frtype").selectmenu("refresh");
    }
}


$('#FR_from').on('change', function() {
    console.log("begindate changed");
    validateRange();
    
    var d = new Date(),
    diff = parseInt(($('#FR_from').datebox('getTheDate') - d) / ( 1000 * 60 * 60 * 24 ));
    diffstrt = (diff * -1)-0; // -0 = same day, -1 = day after, -2 = 1 day between
    diffend = diff + 100;   // maximum of 100 free days per request

    $('#FR_to').data('datebox').options.minDays = diffstrt;
    $('#FR_to').data('datebox').options.maxDays = diffend;
    
});

$('#FR_to').on('change', function() {
    console.log("enddate changed");
    validateRange();
});

/**
 * Make sure endDate is always > beginDate
 */

function validateRange() {
    console.log("validating range...");
    var bd = $('#FR_from').datebox('getTheDate');
    var ed = $('#FR_to').datebox('getTheDate');
    console.log("begindate = " + bd);
    console.log("enddate = " + ed);

    if(ed < bd) {
        console.log("enddate BEFORE begindate!!!");
        ed = bd.copy();
        $('#FR_to').val(parseDate(ed));
        $('#FR_to').datebox('getTheDate') = ed;
    
        console.log("begindate = " + bd);
        console.log("enddate = " + ed);  
    }
}

/**
 * Update date field to match time
 */
function syncTime(date, timeField) {
    var time = $(timeField).val().split(":");
    date.setHours(time[0], time[1], 0, 0);
    console.log("date is now " + date);
}

function submitFreeRequest() {
    
    $('#FR_from').datebox('open').datebox('close');
    $('#FR_to').datebox('open').datebox('close');
    
    var beginDate = $('#FR_from').datebox('getTheDate');
    var endDate = $('#FR_to').datebox('getTheDate');
    
    console.log(lastPublishedSchedule);
    var freeRequestTypeId = $('#select-frtype option:selected').val();
    if (freeRequestTypeId == undefined)
    	freeRequestTypeId = defaultFreeRequestTypeId;
    	
  	console.log(defaultFreeRequestTypeId);
    
    if(beginDate <= lastPublishedSchedule)
        showNotification("Vrijverzoek indienen niet mogelijk", "Er zijn al roosters gepubliceerd na de opgegeven datum. (" + parseDateShort(lastPublishedSchedule) + ")");
        //alert('Vrijverzoek indienen niet mogelijk. Er zijn al roosters gepubliceerd na de opgegeven datum. (' + parseDateShort(lastPublishedSchedule) + ')');
    else {
        syncTime(beginDate, '#FR_fromtime');
        syncTime(endDate, '#FR_totime');
        
        //console.log("begindate = " + beginDate);
        //console.log("enddate = " + $('#FR_to').data('datebox').theDate);
        
        if(endDate <= beginDate)
            showNotification("Fout", "Eindtijd moeten na begintijd liggen");
            //alert("Einddatum en -tijd moeten na begindatum en -tijd liggen.");
        else
            saveFRRequest(beginDate, endDate, freeRequestTypeId, $('#FR_reason').val());
    }
}

/**
 * Call webservice to save new free request
 */
function saveFRRequest(beginDate, endDate, freerequestTypeId, reason) {
    var FreeRequestID = FreeRequest != undefined ? FreeRequest.FreeRequestID : EMPTYGUID;
    var data = {
        "key" : D.Key,
        "freeRequestID" : FreeRequestID,
        "freeRequestTypeID" : freerequestTypeId, // getFrTypeID("Verlof"),
        "beginDate" : fixTimeZone(beginDate).toJSON(),
        "endDate" : fixTimeZone(endDate).toJSON(),
        "reason" : strip_html(reason)
     //   "method" : "saveFRResponse"
    };
    
    console.log(data);
    return CallWCF('SaveFreeRequestMobile', data, "saveFRResponse");
}

/**
 * Called after WCF responds
 */
function saveFRResponse(result) {
    $(":mobile-pagecontainer").pagecontainer("change", "freerequests.html", { allowSamePageTransition: true });
}