var lastPublishedSchedule = null;

$(document).on("pagecreate", "#pschedule-page", function(event) { 
    loadPSchedule();
});

function loadPSchedule() {
    lastPublishedScheduleRequest();
    loadDiv('#myschedule', views + 'loading.html');   
    getScheduleEmployeeRequest();
}

/**
 * Call webservice to get schedule of employee
 */
function getScheduleEmployeeRequest() {
    var b = fixTimeOffset(new Date());
    var weekDay = b.getDay();
    if(weekDay == 0) weekDay = 7;   // sunday fix
    b.setDate(b.getDate() - (weekDay - 1) - 0); // 0 days back DEBUG    
    var e = fixTimeOffset(new Date());
    e.setDate(e.getDate() + 60);        // 2 months forward
    
    var data = {
        "key" : D.Key,
        "beginDate" : b.toJSON(),
        "endDate" : e.toJSON()
    };

    return CallWCF('GetScheduleEmployee', data, "getScheduleEmployeeResponse");
}

/**
 * Called after WCF responds
 */
function getScheduleEmployeeResponse(result) {
    if(result.d == null || result.d.length == 0) {
        setNoPschedule();
    } else {
        var curWeek = 0;
        $('#myschedule li').remove();
        $.each(result.d, function (index, Shift) {            
            var beginTime = getDateFromJSON(Shift.ShiftItem.SH_BeginTime);
            var endTime = getDateFromJSON(Shift.ShiftItem.SH_EndTime);            
            if(beginTime.getWeek() != curWeek) {
            	if (curWeek == 0){
                	curWeek = beginTime.getWeek();
                	$('#myschedule').append('<li data-role="list-divider">Week ' + curWeek + '</li>');
               	}
               	else {
               		curWeek = beginTime.getWeek();
                	$('#myschedule').append('<li data-role="list-divider" style="border-top: 1px solid #15428b;">Week ' + curWeek + '</li>');
               	}
               
            }
            addPScheduleShiftItem(beginTime, endTime, Shift);
        });
        $('#myschedule').listview('refresh');
    }
}

function addWeekDivider(weekNumber) {
    $('#myschedule').append('<li data-role="list-divider" style="border-top: 1px solid #15428b;">Week ' + weekNumber + '</li>');
}

function addPScheduleShiftItem(beginTime, endTime, shift) {
    
    var liClass = parseDateShort(beginTime) == parseDateShort(new Date()) ? 'ui-btn-active smallerPadding' : 'smallerPadding';
    var isFree = false, isPartialFree = false;
    var FrType = null;
    
    $.each(shift.FreeRequestItems, function (i, FreeRequestItem) {      
        if (FreeRequestItem._FreeRequest.FR_Status == "A") {
            var frBegin = getDateFromJSON(FreeRequestItem._FreeRequest.FR_BeginTime);            

            var frEnd;
            if (FreeRequestItem._FreeRequest.FR_EndTime == null || FreeRequestItem._FreeRequest.FR_EndTime == undefined) {
                frEnd = new Date(beginTime);
                frEnd.setDate(beginTime.getDate() + 100);
            }
            else {
                frEnd = getDateFromJSON(FreeRequestItem._FreeRequest.FR_EndTime);
            }
            console.log("frEnd = "  + frEnd);

            if(!(frEnd < beginTime || frBegin > endTime))
            {
                if(frBegin <= beginTime && frEnd >= endTime)
                    isFree = true;
                    
                isPartialFree = true;
                FrType = getFrType(FreeRequestItem._FreeRequest.FreeRequestTypeID);
            }            
        }
    });
    
    var shiftInfo = parseShiftTimes(beginTime, endTime);
    if(isFree){
        var frColor = parseDateShort(beginTime) == parseDateShort(new Date()) ? '#15428b' : '#15428b';
	    shiftInfo = "<span style='color:" + intToHexColor(FrType.FRT_ColorInt) + ";text-decoration:line-through'><span style='color: "+ frColor + "'>" + shiftInfo + "</span></span>";
   	} 
    //"<s style='text-decoration: line-through'>" + shiftInfo + "</s>";
    if(!isFree && isPartialFree) shiftInfo += " *";
    if(isPartialFree) {   
        shiftInfo += "<font style='-webkit-text-stroke: 0.5px black;' color='" + intToHexColor(FrType.FRT_ColorInt) + "'>" + 
        " " + FrType.FRT_Name.substring(0,1) + "</font>";
    }
    var locInfo = "";
    if(shift.LocationID != D.Location.LocationID) locInfo = shift.LO_Name.substring(0,7) + " (" + shift.DE_Name.substring(0,4) + ")";    
    else if(D.Departments.length > 1) locInfo = shift.DE_Name.substring(0,10);
    
    if (locInfo != "")
    	shiftInfo += "<br/><font style='font-weight: normal;'>" + locInfo + "</font>";
   
   //console.log(shift);
   
    $('#myschedule').append('<li class="' + liClass + '"><div class="ui-grid-b mediumText">' +
        '<div class="ui-block-a">' + parseDateShort(beginTime) + '</div>' +
        '<div class="ui-block-b w50pt">' + shiftInfo + '</div>' +
        '<div class="ui-block-c w20pt"><span class="employee-function" style="background-color: ' + 
        intToHexColor(shift.ShiftItem.Function.FN_Color) + '">' + shift.ShiftItem.Function.FN_ShortName + '</span></div></div></li>');
}

function setNoPschedule() {
    $('#myschedule li').remove();
    $('#myschedule').append('<li>Je staat momenteel niet ingeroosterd</li>');
    $('#myschedule').listview('refresh');
}

/**
 * Call webservice to get date of last published schedule
 */
function lastPublishedScheduleRequest(departmentId) {
	console.log("lastpubschedule "+departmentId);
	if (departmentId == undefined)
		departmentId = D.Departments[0].DepartmentID;
    var data = { "key" : D.Key, "departmentId" : departmentId };
    
    var allowFrom = new Number;
    allowFrom = -1;
	for(i = 0; i < D.Settings.length; i++) {
		if(D.Settings[i].Name == "Portal_AllowFreeRequestsFrom") {
	        allowFrom = D.Settings[i].Value;
	    }
	}
		
	console.log("lastpubschedule CALLWCF"+allowFrom); 
	if (allowFrom == -1) {   
		
    	return CallWCF('LastPublishedSchedule', data, "lastPublishedScheduleResponse");
    }
    else {
    	var lps = new Date();
    	lastPublishedSchedule = new Date(lps.getFullYear(),lps.getMonth(),lps.getDate()+parseInt(allowFrom));
    	//$('#lastPubScheduleDate').text(parseDateLong(lastPublishedSchedule));    	
		$('#lastPubScheduleDate').text("");    	
    }     	    
}

/**
 * Called after WCF responds
 */
function lastPublishedScheduleResponse(result) {
	console.log("lps = " + result.d);
    lastPublishedSchedule = (result.d == null || result.d.length == 0) ? new Date() : getDateFromJSON(result.d);
    lastPublishedSchedule.setDate(lastPublishedSchedule.getDate());
    $('#lastPubScheduleDate').text(parseDateLong(lastPublishedSchedule));
}